# Multiplexer

Un multiplexer, o *mux*, e' un dispositivo che consente ci collegare piu' ingressi a una singola uscita. Un multiplexer da terminale permette di passare tra diversi ingressi o sessioni. Due esempi sono `screen` e `tmux`.

Le sessioni possono essere scollegate dal terminale corrente, coi programmi che continuano ad essere eseguiti in background.

##  screen

Invocato semplicemente digitando `screen` sul terminale. Il file di configurazione e' `~/.screenrc`

Ogni comando e' preceduto dalla combinazione `CTRL + a`.

Un elenco dei comandi principali:

- `CTRL + a + w`: mostra l'elenco delle finestre. Il conteggio parte da 0
- `CTRL + a + c`: crea una nuova finestra (il simbolo `*` indica la finestra corrente)

```bash
0-$ bash 1*$ bash
```

- `CTRL + a + A`: rinominare la finestra corrente
- `screen -t anotherwindow`: crea una finestra con un nome stabilito
- `CTRL + a + n`: spostarsi alla finestra successiva
- `CTRL + a + p`: precedente
- `CTRL + a + number`: alla finestra *number*
- `CTRL + a + k`: chiude la finestra attualmente in uso
- `CTRL + a + S`: divide il terminale in due regioni orizzontali
- `CTRL + a + |`: verticalmente
- `CTRL + a + Tab`: muoversi tra le regioni
- `CTRL + a + Q`: termina tutte le regioni
- `CTRL + a + X`: termina la regione corrente
- `CTRL + a + D`: distacco dalla sessione

Alcune opzioni di screen:

- `screen -ls`: mostra un elenco di tutte le sessioni
- `screen -S new-session`: creare una nuova sessione con nome *new-session*
- `screen -R SESSION-PID` o `screen -R SESSION-NAME`: collegarsi alla medesima sessione
- `screen -t SESSION-NAME COMMAND`: crea una sessione SESSION-NAME, nella quale sara' eseguito il comando COMMAND. Ad esempio: `screen -t top top`

### Copia e incolla: scrollback-mode

- `CTRL + a + [`: accedere alla scrollback-mode
- Spostarsi all'inizio del testo da copiare coi tasti freccia
- Premere `Space`, per segnale l'inizio della selezione del testo
- Spostarsi coi tasti freccia fino al termine del testo da copiare
- Premere `Space`, per segnale il termine della selezione del testo
- `CTRL + a + ]`: permette di incollare il testo

## tmux